use crate::{state::{GameState, Action}, creature::Creature, site::Town};

pub struct PersonGenesis {
    pub town: Town,
    pub person: Creature,
}

impl Action for PersonGenesis {
    fn apply(&self, state: &mut GameState) {
        state.add_person(self.person.clone());
    }

    fn description(&self) -> String {
        format!("{} was sent by the Gods to {}", self.person.name, self.town.name)
    }

    fn notable(&self) -> bool {
        true
    }
}